#Include <File.au3>
#Include <Date.au3>


#cs

Script to measure the length of speech of lines of text in a text file.

1. Read lines in text file one by one
2. Save line as new text file X.txt
3. Open X.txt in ReadPlease FREE
4. Take a time stamp
5. Read the text
6. Detect end of reading
7. Take a time stamp
8. Calculate time length
9. Write time stamp, TAB, and line to new text file.

At start of script, user must indicate green play triangle with mouse.  Reading is done when triangle is no longer grey.

#ce

$sourcefilename = FileOpenDialog ("1. Select file with text strings", "", "Text files (*.txt)")

$targetfilename = FileSaveDialog ("2. Type file name for results file", "", "Text files (*.txt)")

MsgBox (0, "3. Run ReadPlease FREE", "Please launch ReadPlease FREE, make sure it is visible on your screen, and click 'OK' here when you've done it.", 0)

MsgBox (0, "4. Select green Play triangle", "Hover your mouse over the green 'Play' triangle on the left-hand side of ReadPlease FREE, and press ENTER.  The script will capture the mouse position and colour after 2 seconds.  Remember, the point of the mouse pointer must be inside the green triangle.", 0)

Sleep ("2000")

$pos = MouseGetPos ()

Sleep ("100")

$green = PixelGetColor ($pos[0], $pos[1])

MsgBox(0, "Thanks!", "Position and colour captured!  Remember, don't move the ReadPlease FREE window to a different location on the screen.", 0)

MsgBox(0, "5. Now let her rip!", "Mute the volume and do not do anything else on this computer until you're told that it is safe to do so.  You can pause or cancel the script using the Systray icon.  Click 'OK' to begin.", 0)

$sfileopen = FileOpen ($sourcefilename, 128)

$linecount = _FileCountLines($sourcefilename)

MsgBox (0, "", $linecount & " lines will be read.", 0)

For $i = 1 to $linecount

$line = FileReadLine ($sfileopen, $i)

WinActivate ("ReadPlease", "")
WinWaitActive ("ReadPlease", "")

Send ("!f")
Send ("c")

ClipPut ($line)
Sleep ("100")

Send ("^v")
Sleep ("100")

$begintimer = TimerInit()

Send ("!c")
Send ("p")

While 1
Sleep ("500")
$nowcolour = PixelGetColor ($pos[0], $pos[1])
If $nowcolour = $green Then ExitLoop
WEnd

$timedif = TimerDiff($begintimer) / 1000

$floortimedif = Floor ($timedif)

$writefileopen = FileOpen ($targetfilename, 129)
FileWrite ($writefileopen, $floortimedif & @TAB & $line & @CRLF)
FileClose ($writefileopen)

Next

MsgBox (0, "Done!", "Finished reading " & $i & " lines.  The results file has two columns -- the number of seconds (rounded down) to read the line, and the line itself.  You can paste it in Excel and do some calculations on it, if you want.", 0)



